Subject: Re: [PATCH net-next] mlx4: make sure to always set the port type

From: Leon Romanovsky <[email-masked]>
Date: Mon, 7 Sep 2020 12:10:07 +0300

On Mon, Sep 07, 2020 at 09:19:39AM +0200, Jiri Pirko wrote:
> Mon, Sep 07, 2020 at 08:48:30AM CEST, [email-masked] wrote:
> >On Mon, Sep 07, 2020 at 08:21:35AM +0200, Jiri Pirko wrote:
> >> Sun, Sep 06, 2020 at 06:33:05PM CEST, [email-masked] wrote:
> >> >On Sun, 6 Sep 2020 10:27:59 +0300 Leon Romanovsky wrote:
> >> >> On Fri, Sep 04, 2020 at 01:06:21PM -0700, Jakub Kicinski wrote:
> >> >> > Even tho mlx4_core registers the devlink ports, it's mlx4_en
> >> >> > and mlx4_ib which set their type. In situations where one of
> >> >> > the two is not built yet the machine has ports of given type
> >> >> > we see the devlink warning from devlink_port_type_warn() trigger.
> >> >> >
> >> >> > Having ports of a type not supported by the kernel may seem
> >> >> > surprising, but it does occur in practice - when the unsupported
> >> >> > port is not plugged in to a switch anyway users are more than happy
> >> >> > not to see it (and potentially allocate any resources to it).
> >> >> >
> >> >> > Set the type in mlx4_core if type-specific driver is not built.
> >> >> >
> >> >> > Signed-off-by: Jakub Kicinski <[email-masked]>
> >> >> > ---
> >> >> >  drivers/net/ethernet/mellanox/mlx4/main.c | 11 +++++++++++
> >> >> >  1 file changed, 11 insertions(+)
> >> >> >
> >> >> > diff --git a/drivers/net/ethernet/mellanox/mlx4/main.c b/drivers/net/ethernet/mellanox/mlx4/main.c
> >> >> > index 258c7a96f269..70cf24ba71e4 100644
> >> >> > --- a/drivers/net/ethernet/mellanox/mlx4/main.c
> >> >> > +++ b/drivers/net/ethernet/mellanox/mlx4/main.c
> >> >> > @@ -3031,6 +3031,17 @@ static int mlx4_init_port_info(struct mlx4_dev *dev, int port)
> >> >> >  	if (err)
> >> >> >  		return err;
> >> >> >
> >> >> > +	/* Ethernet and IB drivers will normally set the port type,
> >> >> > +	 * but if they are not built set the type now to prevent
> >> >> > +	 * devlink_port_type_warn() from firing.
> >> >> > +	 */
> >> >> > +	if (!IS_ENABLED(CONFIG_MLX4_EN) &&
> >> >> > +	    dev->caps.port_type[port] == MLX4_PORT_TYPE_ETH)
> >> >> > +		devlink_port_type_eth_set(&info->devlink_port, NULL);
> >> >>                                                                ^^^^^
> >> >>
> >> >> Won't it crash in devlink_port_type_eth_set()?
> >> >> The first line there dereferences pointer.
> >> >>   7612         const struct net_device_ops *ops = netdev->netdev_ops;
> >> >
> >> >Damn, good catch. It's not supposed to be required. I'll patch devlink.
> >>
> >> When you set the port type to ethernet, you should have the net_device
> >> instance. Why wouldn't you?
> >
> >It is how mlx4 is implemented, see mlx4_dev_cap() function:
> >588         for (i = 1; i <= dev->caps.num_ports; ++i) {
> >589                 dev->caps.port_type[i] = MLX4_PORT_TYPE_NONE;
> >....
> >
> >The port type is being set to IB or ETH without relation to net_device,
> >fixing it will require very major code rewrite for the stable driver
> >that in maintenance mode.
>
> Because the eth driver is not loaded, I see. The purpose of the
> WARN in devlink_port_type_eth_set is to prevent drivers from registering
> particular port without netdev/ibdev. That is what was repeatedly
> happening in the past as the driver developers didn't know they need to
> do it or were just lazy to do so.
>
> I wonder if there is any possibility to do both...

It is hard to say, hope that Jakub will take a look.

Thanks

>
> >
> >>
> >>
> >> >
> >> >> And can we call to devlink_port_type_*_set() without IS_ENABLED() check?
> >> >
> >> >It'll generate two netlink notifications - not the end of the world but
> >> >also doesn't feel super clean.
> >
> >I would say that such a situation is corner case during the driver init and
> >not an end of the world to see double netlink message.
> >
> >Thanks